/*
 * thread.h
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * This code interfaces assembler instructions to send and
 * receive messages between contexts in the ssmt.
 *
 * This code is part of libssmt.a
 *
 */

#include "libssmt.h"


typedef struct {
  SS_WORD_TYPE *stack;
  unsigned int stack_size;
  unsigned int thread_id;
  unsigned int context_id;
  unsigned int *context_save;
} thread_descriptor_t;



