/*
 * test-ssmt-d
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * This program is launched in conjunction with test-ssmt-a.
 * The later emit a signal which is receive by this program.
 * Then the register 27 of the context 0 is written and a
 * signal is sent.
 *
 */

#include <stdio.h>

#define exec_name "test-ssmt-d"

void main(int argc, char **argv)
{
  unsigned int cxtid, rs;

  /* getting context id */
  asm("scxtctrl %0" : "=r" (cxtid));
  cxtid = cxtid & 0x0000001f;

  fprintf(stdout, "[%d] BEGIN (%s)\n", cxtid, exec_name);

  asm("rmsg %0,1" : "=r" (rs));
  fprintf(stdout, "[%d] msg %d received\n", cxtid, rs);

  fprintf(stdout, "[%d] END (%s)\n", cxtid, exec_name);

}
