/*
 * test-ssmt-e
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 *
 *
 */

#include <stdio.h>
#include "libssmt.h"


#define EXEC_NAME "test-ssmt-e"
#define MAX_LOOP 1000
#define NUM_CXT 8

void main(int argc, char **argv)
{
  unsigned int i, me;
  SS_WORD_TYPE msg;

  me = contextID();
  msg = 0;

/*   fprintf(stderr, "[%d] BEGIN (%s)\n", me, EXEC_NAME); */

  if (me == 0) {
/*     fprintf(stderr, "[%d] sending message 0x%08x to %d\n", */
/*             me, msg, (me + 1) % NUM_CXT); */
    sendToContext(msg, (me + 1) % NUM_CXT);
  } /* if */
  for(i = 0; i < MAX_LOOP; i++) {
/*     fprintf(stderr, "[%d] waiting for message from %d\n", */
/*             me, (me + 1) % NUM_CXT); */
    receiveFromContext(&msg, (me + NUM_CXT - 1) % NUM_CXT);
/*     fprintf(stderr, "[%d] message received from %d: 0x%08x\n", */
/*             me, (me + NUM_CXT - 1) % NUM_CXT, msg); */
    if (i % 10)
      msg += (1 << (4*me));
    else
      msg &= ~(0xf << (4*me));
    if (/* first context shouldn't send at last */
        !((me == 0) && (i == MAX_LOOP - 1))) {
/*       fprintf(stderr, "[%d] sending message 0x%08x to %d\n", */
/*               me, msg, (me + 1) % NUM_CXT); */
      sendToContext(msg, (me + 1) % NUM_CXT);
    } /* if */
  } /* for */
            
/*   fprintf(stderr, "[%d] END (%s)\n", me, EXEC_NAME); */

}
