#!/usr/bin/env perl
#
# strip.pl
#

my @address;
my $location;
my $line;
my $elem;

my @spy = ("0x004008d8", "0x004008e0", "0x00400940", "0x00400948",
           "0x00400cf8", "0x00400d00", "0x00400e10", "0x00400e18");
my @what = ("lock 1 in   ", "lock 1 out  ", "unlock 1 in ", "unlock 1 out",
            "lock 2 in   ", "lock 2 out  ", "unlock 2 in ", "unlock 2 out");

mainloop: 
  while ($line = <STDIN>) {
  my $found = 0;

  if ($line =~ /^\-/) {
    next mainloop;
  } elsif ($line =~ /^\+/) {
    my $place = 0;
    foreach $elem (@spy) {
      $elem = "(?i)".$elem;
      if ($line =~ /$elem/) {
        $line =~ /^. . ([0-9]*)/;
        push(@address, $1);
        print $what[$place]." \@ ".$location." ".$line;
        next mainloop;
      } else {
        $place++;
      }
    }
    next mainloop;
  } elsif ($line =~ /^\@ ([0-9]*)/) {
    $location = $1;
    next mainloop;
  } else {
    my $place = 0;
    foreach $elem (@address) {
      $elem = "(?i)".$elem;
      if ($line =~ /$elem/) {
        if ($line =~ /^. . ([0-9]*) EX.*/) {
          print "             \@ ".$location." ".$line;
          next mainloop;
        }
        if ($line =~ /^. . ([0-9]*) CT.*/) {
          print "             \@ ".$location." ".$line;
          splice @address, $place, 1;
          next mainloop;
        }
      }
      $place++;
    } # foreach
  } # if
} # while
